//
//  NSFileManager(TRAdditions).m
//  Tryst
//
//  Created by Francisco Tolmasky on Fri Mar 19 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "NSFileManager+TRAdditions.h"


@implementation NSFileManager (TRAdditions)

+ (NSURL *)safeSupportFolder
{
    NSURL *url= [NSURL fileURLWithPath: [[[NSFileManager defaultManager] 
        findSystemFolderType: kApplicationSupportFolderType 
        forDomain: kUserDomain] stringByAppendingString: @"/Tryst"]];
    BOOL isDirectory;
    if(![[NSFileManager defaultManager] fileExistsAtPath: [url path] isDirectory: &isDirectory] || !isDirectory)
        [[NSFileManager defaultManager] createDirectoryAtPath: [url path] attributes: nil];
    return url;
}

- (NSString *)findSystemFolderType:(int)folderType forDomain:(int)domain 
 { 
    FSRef folder; 
    OSErr err= noErr; 
    CFURLRef url; 
    NSString *result = nil; 
  
    err= FSFindFolder(domain, folderType, false, &folder);
    
    if(err==noErr)
    {
        url= CFURLCreateFromFSRef(kCFAllocatorDefault, &folder);
        result= [(NSURL *)url path];
    }
    return result; 
}

@end
