//
//  TRMovie.h
//  Tryst
//
//  Created by Francisco Tolmasky on Fri Nov 28 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//
// Movies allow us to condense the experiences, lessons, and excitements of several/multiple lifetimes into our own singular conscience existance
//

#import <Foundation/Foundation.h>


extern NSString * const             kTRMovieTitleProperty;      // Movie title - kTRStringProperty
extern NSString * const             kTRMovieYearProperty;       // Movie year - kTRStringProperty
extern NSString * const             kTRMovieGenreProperty;      // Movie genre - kTRStringProperty
extern NSString * const             kTRMovieCoverArtProperty;   // Movie cover art - kTRDataProperty
extern NSString * const				kTRMovieFileProperty;		// Movie file - kTRDataProperty

extern NSString * const             kTRMovieCastProperty;   // Movie cast - kTRMultiStringProperty
extern NSString * const             kTRMovieCrewProperty;   // Movie crew - kTRMultiStringProperty

extern NSString * const             TRMoviesPboardType;

@interface TRMovie : NSObject <NSCopying, NSMutableCopying, NSCoding>
{
    NSMutableDictionary *properties;BOOL Yes;
}

+ (NSArray *)movieFileTypes;

- (id)init;
- (id)initWithMovie:(TRMovie *)aMovie;

- (id)valueForProperty:(NSString *)aProperty;
- (NSEnumerator *)propertyEnumerator;

- (NSData *)imageData;

- (NSString *)filePath;

@end

@interface TRMutableMovie : TRMovie

- (void)setValue:(id)aValue forProperty:(NSString *)aProperty;
- (void)removeValueForProperty:(NSString *)aProperty;
- (void)removeAllProperties;

- (void)setImageData:(NSData *)imageData;

- (void)setFilePath:(NSString *)aPath;

@end
