//
//  NSString(TRDrawingAdditions).m
//  Tryst
//
//  Created by Francisco Tolmasky on Fri Jan 23 2004.
//  Copyright (c) 2004 Francisco Tolmasky. All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
//

#import <Carbon/Carbon.h>
#import "NSString+TRDrawingAdditions.h"


@implementation NSString(TRDrawingAdditions)

+ (NSString *)stringWithFileSize:(unsigned)bytes
{
	if(bytes>1073741824) return [NSString stringWithFormat: @"%.1f GB", bytes/1073741824.0];
	else if(bytes>1048576) return [NSString stringWithFormat: @"%.1f MB", bytes/1048576.0];
	return [NSString stringWithFormat: @"%.1f KB", bytes/1024.0];
}

- (NSAttributedString *)truncatedStringWithAttributes:(NSDictionary *)attributes
    width:(float)aWidth
{
    NSMutableString *text = [self mutableCopy];
    NSMutableAttributedString *s = [NSAttributedString alloc];
    OSStatus err= TruncateThemeText((CFMutableStringRef) text, kThemeViewsFont,
                        kThemeStateActive, aWidth, truncEnd, NULL);
    if (err != noErr) NSLog(@"TruncateThemeText failed with error %d", err);
    // XXX Should be able to skip the above by using NSLineBreakByTruncatingMiddle,
    // XXX but OS X 10.1 doesn't implement it yet.
    s = [s initWithString: text attributes: attributes];
    [text release];
    return s;
}

@end
