/*****************************************************************************
 * modules_builtin.h: built-in modules list
 *****************************************************************************
 * Copyright (C) 2001 VideoLAN
 *
 * Authors: Samuel Hocevar <sam@zoy.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#define ALLOCATE_BUILTIN( NAME ) \
    AllocateBuiltinModule( p_this, vlc_entry__ ## NAME );

/* We also consider the main program as a module (useful for config stuff) */
int vlc_entry__main( module_t* );

/* Add stuff here */
int vlc_entry__memcpyaltivec( module_t* );
int vlc_entry__i420_yuy2_altivec( module_t* );
int vlc_entry__livedotcom( module_t* );
int vlc_entry__mkv( module_t* );
int vlc_entry__ffmpeg( module_t* );
int vlc_entry__stream_out_transcode( module_t* );
int vlc_entry__quicktime( module_t* );
int vlc_entry__theora( module_t* );
int vlc_entry__coreaudio( module_t* );
int vlc_entry__macosx( module_t* );

#define ALLOCATE_ALL_BUILTINS() \
    do \
    { \
        ALLOCATE_BUILTIN(memcpyaltivec); \
        ALLOCATE_BUILTIN(i420_yuy2_altivec); \
        ALLOCATE_BUILTIN(livedotcom); \
        ALLOCATE_BUILTIN(mkv); \
        ALLOCATE_BUILTIN(ffmpeg); \
        ALLOCATE_BUILTIN(stream_out_transcode); \
        ALLOCATE_BUILTIN(quicktime); \
        ALLOCATE_BUILTIN(theora); \
        ALLOCATE_BUILTIN(coreaudio); \
        ALLOCATE_BUILTIN(macosx); \
    } while( 0 );

